routes/web.php
<?php

use App\Http\Controllers\Admin\AdminPagesController;
use App\Http\Controllers\Admin\CarsController;
use App\Http\Controllers\Admin\ArticlesController;
use App\Http\Controllers\ArticlesController as BaseArticles;
use App\Http\Controllers\BasketController;
use App\Http\Controllers\CallbackController;
use App\Http\Controllers\CatalogController;
use App\Http\Controllers\Manager\ManagerPagesController;
use App\Http\Controllers\OrdersController;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SalonsController;
use App\Http\Controllers\ServiceController;
use App\Http\Controllers\TestDriveController;
use Illuminate\Routing\Router;
use Illuminate\Support\Facades\Route;

Route::get('/', [PagesController::class, 'homepage'])->name('home');

Route::get('/about', [PagesController::class, 'about'])->name('about');

Route::get('/catalog/{slug?}', [CatalogController::class, 'catalog'])->name('catalog');
Route::get('/products/{car:id}', [CatalogController::class, 'product'])->name('product');

Route::get('/salons', [SalonsController::class, 'index'])->name('salons.index');

Route::get('/basket', [BasketController::class, 'show'])->name('basket');
Route::post('/basket', [BasketController::class, 'addProduct'])->name('basket.addProduct');
Route::delete('/basket/deleteProduct/', [BasketController::class, 'deleteProduct'])->name('basket.deleteProduct');
Route::delete('/basket/removeProduct', [BasketController::class, 'removeProduct'])->name('basket.removeProduct');

Route::get('/callback', [CallbackController::class, 'show'])->name('callback.show');
Route::post('/callback', [CallbackController::class, 'store'])->name('callback.store');
Route::post('/callback/{id}', [CallbackController::class, 'update'])->name('callback.update');

Route::get('/test-drive', [TestDriveController::class, 'show'])->name('test-drive.show');
Route::post('/test-drive', [TestDriveController::class, 'store'])->name('test-drive.store');

Route::get('/service', [ServiceController::class, 'show'])->name('service.show');

Route::middleware('auth')->group(function () {
    Route::get('/basket', [BasketController::class, 'show'])->name('basket');
    Route::post('/basket', [BasketController::class, 'addProduct'])->name('basket.addProduct');
    Route::delete('/basket/deleteProduct/', [BasketController::class, 'deleteProduct'])->name('basket.deleteProduct');
    Route::delete('/basket/removeProduct', [BasketController::class, 'removeProduct'])->name('basket.removeProduct');
});

Route::get('/articles', [BaseArticles::class, 'index'])->name('articles.index');
Route::get('/articles/{slug}', [BaseArticles::class, 'show'])->name('articles.show');

Route::prefix('admin')
    ->name('admin.')
    ->middleware(['auth', 'role:admin'])
    ->group(function (Router $router) {
        $router->get('/', [AdminPagesController::class, 'admin'])->name('admin');
        $router->resource('cars', CarsController::class)->except(['show']);
        $router->resource('articles', ArticlesController::class)->except(['show']);
    })
;

Route::prefix('test-drive')
    ->name('manager.test-drive.')
    ->middleware(['auth', 'role:manager'])
    ->group(function (Router $router) {
        $router->post('/{id}', [TestDriveController::class, 'update'])->name('update');
        $router->get('/{id}/edit', [TestDriveController::class, 'edit'])->name('edit');
        $router->delete('/{id}', [TestDriveController::class, 'destroy'])->name('destroy');
    })
;

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
    Route::post('/profile/orders', [OrdersController::class, 'store'])->name('orders.create');
});

Route::prefix('manager')
    ->name('manager.')
    ->middleware(['auth', 'role:manager'])
    ->group(function (Router $router) {
        $router->get('/', [ManagerPagesController::class, 'manager'])->name('manager');
    })
;

require __DIR__.'/auth.php';

app/Models/Article.php
<?php

namespace App\Models;

use App\Contracts\HasTagsContract;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\MorphToMany;

class Article extends Model implements HasTagsContract
{
    use HasFactory;

    public function getRouteKeyName(): string
    {
        return 'slug';
    }

    protected $fillable = ['title', 'description', 'body', 'slug', 'image', 'published_at', 'image_id'];

    protected $casts = [
        'published_at' => 'datetime:d M Y',
    ];

    public function tags(): MorphToMany
    {
        return $this->morphToMany(Tag::class, 'taggable');
    }

    public function image(): BelongsTo
    {
        return $this->belongsTo(Image::class);
    }

    public function imageUrl(): Attribute
    {
        return Attribute::get(fn () => $this->image?->url ?: '/assets/images/no_image.png');
    }
}

app/Http/Controllers/Admin/ArticlesController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Contracts\Services\Articles\ArticleCreationServiceContract;
use App\Contracts\Services\Articles\ArticleRemoverServiceContract;
use App\Contracts\Services\Articles\ArticleUpdateServiceContract;
use App\Contracts\Services\FlashMessageContract;
use App\Http\Requests\Admin\ArticleRequest;
use App\Http\Requests\TagsRequest;
use App\Models\Article;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Contracts\Repositories\ArticlesRepositoryContract;
use Illuminate\View\View;

class ArticlesController extends Controller
{
    public function __construct(
        private ArticlesRepositoryContract $articlesRepository
    ) {
    }

    public function index(Request $request): View
    {
        $this->authorize('viewAny', Article::class);

        $articles = $this->articlesRepository->findAll();

        return view('pages.admin.articles.list', compact('articles'));
    }

    public function create(): View
    {
        $this->authorize('create', Article::class);

        $article = $this->articlesRepository->getModel();
        return view('pages.admin.articles.create', compact('article'));
    }

    public function store(
        ArticleRequest $request,
        TagsRequest $tagsRequest,
        FlashMessageContract $flashMessage,
        ArticleCreationServiceContract $createArticleService
    ): RedirectResponse {
        $this->authorize('create', Article::class);

        $createArticleService->create($request->validated(), $tagsRequest->get('tags'));

        $flashMessage->success('Новость успешно создана');

        return redirect()->route('admin.articles.index');
    }

    public function edit(string $slug): View
    {
        $article = $this->articlesRepository->findBySlug($slug);

        $this->authorize('update', $article);

        return view('pages.admin.articles.edit', compact('article'));
    }

    public function update(
        ArticleRequest $request,
        string $slug,
        TagsRequest $tagsRequest,
        FlashMessageContract $flashMessage,
        ArticleUpdateServiceContract $updateArticleService
    ): RedirectResponse {
        $this->authorize('update', $this->articlesRepository->findBySlug($slug));

        $article = $updateArticleService->update($slug, $request->validated(), $tagsRequest->get('tags'));

        $flashMessage->success('Новость успешно обновлена');

        return redirect(route('admin.articles.edit', $article));
    }

    public function destroy(
        string $slug,
        FlashMessageContract $flashMessage,
        ArticleRemoverServiceContract $articleRemoverService
    ): RedirectResponse {
        $this->authorize('update', $this->articlesRepository->findBySlug($slug));

        $articleRemoverService->delete($slug);

        $flashMessage->success('Новость удалена');

        return back();
    }
}

app/Http/Controllers/ArticlesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Contracts\Repositories\ArticlesRepositoryContract;

class ArticlesController extends Controller
{
    public function __construct(
        private ArticlesRepositoryContract $articlesRepository
    ) {
    }

    public function index(Request $request)
    {
        $allArticles = $this->articlesRepository->paginateForArticlesList(5, ['*'], 'page', $request->get('page', 1), ['image', 'tags']);

        return view('pages.articles', compact('allArticles'));
    }

    public function show(string $slug)
    {
        $article = $this->articlesRepository->findBySlug($slug);
        return view('pages.article', compact('article'));
    }
}

resources/views/pages/admin/articles/create.blade.php
<x-layouts.admin
    page-title="Форма создания новости"
    title="Форма создания новости"
>
    <x-forms.form action="{{ route('admin.articles.store') }}" method="post" enctype="multipart/form-data">

        <x-forms.concrete-forms-fields.admin-article-form-fields :article="$article" />

        <x-forms.row>
            <x-forms.submit-button>
                Сохранить
            </x-forms.submit-button>
            <x-forms.cancel-button href="{{ route('admin.articles.index') }}" >
                Отменить
            </x-forms.cancel-button>
        </x-forms.row>
    </x-forms.form>
</x-layouts.admin>

resources/views/pages/admin/articles/edit.blade.php
<x-layouts.admin
    page-title="Форма редактирования новости"
    title="Форма редактирования новости"
>
    <x-forms.form action="{{ route('admin.articles.update', ['article' => $article]) }}" method="post" enctype="multipart/form-data">
        @method('PATCH')

        <x-forms.concrete-forms-fields.admin-article-form-fields :article="$article" />

        <x-forms.row>
            <x-forms.submit-button>
                Сохранить
            </x-forms.submit-button>
            <x-forms.cancel-button href="{{ route('admin.articles.edit', ['article' => $article]) }}">
                Отменить
            </x-forms.cancel-button>
        </x-forms.row>
    </x-forms.form>
</x-layouts.admin>

resources/views/pages/admin/articles/list.blade.php
<x-layouts.admin
    page-title="Управление новостями"
    title="Управление новостями"
>
    <section class="pb-4">
        @can('create', \App\Models\Article::class)
        <div class="my-6">
            <a href="{{ route('admin.articles.create') }}" class="inline-block bg-orange hover:bg-opacity-70 focus:outline-none text-white font-bold py-2 px-4 rounded" title="Добавить новость">
                <span class="flex items-center space-x-2">
                    <svg xmlns="http://www.w3.org/2000/svg" class="inline-block h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
                        <path stroke-linecap="round" stroke-linejoin="round" d="M12 9v3m0 0v3m0-3h3m-3 0H9m12 0a9 9 0 11-18 0 9 9 0 0118 0z" />
                    </svg>
                    <span>Добавить новость</span>
                </span>
            </a>
        </div>
        @endcan

        <table class="border border-collapse w-full">
            <thead>
            <tr>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">id</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">Заголовок новости</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">Краткое описание</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">Дата публикации</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">Теги</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">&nbsp;</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">&nbsp;</th>
            </tr>
            </thead>
            <tbody>
            @foreach ($articles as $article)
            <tr>
                <td class="border px-4 py-2">{{ $article->id }}</td>
                <td class="border px-4 py-2">{{ $article->title }}</td>
                <td class="border px-4 py-2">{{ $article->description }}</td>
                <td class="border px-4 py-2">{{ $article->published_at }}</td>
                <td class="border px-4 py-2">
                    @can('update', $article)
                        <div class="flex items-center">
                            <a href="{{ route('admin.articles.edit', ['article' => $article]) }}" class="inline-block bg-orange hover:bg-opacity-70 focus:outline-none text-white font-bold py-2 px-4 rounded" title="Редактировать">
                                <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" viewBox="0 0 20 20" fill="currentColor">
                                    <path d="M17.414 2.586a2 2 0 00-2.828 0L7 10.172V13h2.828l7.586-7.586a2 2 0 000-2.828z" />
                                    <path fill-rule="evenodd" d="M2 6a2 2 0 012-2h4a1 1 0 010 2H4v10h10v-4a1 1 0 112 0v4a2 2 0 01-2 2H4a2 2 0 01-2-2V6z" clip-rule="evenodd" />
                                </svg>
                            </a>
                        </div>
                    @endcan
                </td>
                <td class="border px-4 py-2">
                    @can('delete', $article)
                        <form class="flex items-center" action="{{ route('admin.articles.destroy', ['article' => $article]) }}" method="post">
                            @csrf
                            @method('DELETE')
                            <button class="inline-block bg-gray-400 hover:bg-opacity-70 focus:outline-none text-white font-bold py-2 px-4 rounded" title="Удалить" onclick="return confirm('вы уверены, что хотите удалить эту новость?')">
                                <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
                                    <path stroke-linecap="round" stroke-linejoin="round" d="M19 7l-.867 12.142A2 2 0 0116.138 21H7.862a2 2 0 01-1.995-1.858L5 7m5 4v6m4-6v6m1-10V4a1 1 0 00-1-1h-4a1 1 0 00-1 1v3M4 7h16" />
                                </svg>
                            </button>
                        </form>
                    @endcan
                </td>
            </tr>
            @endforeach
            </tbody>
        </table>
    </section>
</x-layouts.admin>